org.apache.solr.client.solrj.io.stream

## Class SqlStream

- java.lang.Object
- - org.apache.solr.client.solrj.io.stream.TupleStream
  - - org.apache.solr.client.solrj.io.stream.SqlStream

All Implemented Interfaces:
  Closeable, Serializable, AutoCloseable, Expressible, MapSerializable, MapWriter, NavigableObject

    public class SqlStream
    extends TupleStream
    implements Expressible

Since:
  7.0.0
See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.solr.client.solrj.io.stream.TupleStream

`TupleStream.IgnoreException`

### Nested classes/interfaces inherited from interface org.apache.solr.common.MapWriter

`MapWriter.EntryWriter`

### Field Summary

Fields
`protected CloudSolrClient` `cloudSolrClient`
`protected String` `collection`
`protected SolrParams` `params`
`protected StreamContext` `streamContext`
`protected TupleStream` `tupleStream`
`protected String` `zkHost`

### Constructor Summary

Constructors
Constructor and Description
`SqlStream(StreamExpression expression, StreamFactory factory)`
`SqlStream(String zkHost, String collectionName, SolrParams params)`

### Method Summary

All Methods Instance Methods Concrete Methods
`List<TupleStream>` `children()`
`void` `close()`
`protected void` `constructStream()`
`StreamComparator` `getStreamSort()` Return the stream sort - ie, the order in which records are returned
`protected void` `init(String collectionName, String zkHost, SolrParams params)`
`void` `open()`
`Tuple` `read()`
`void` `setStreamContext(StreamContext context)`
`Explanation` `toExplanation(StreamFactory factory)` Returns an explanation about the stream object
`StreamExpression` `toExpression(StreamFactory factory)`

### Methods inherited from class org.apache.solr.client.solrj.io.stream.TupleStream

`getCost, getShards, getShards, getStreamNodeId, writeMap`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.solr.common.MapWriter

`jsonStr, toMap`

### Methods inherited from interface org.apache.solr.common.NavigableObject

`_forEachEntry, _forEachEntry, _forEachEntry, _get, _get, _getStr, _getStr, _size`

### Field Detail

#### zkHost

    protected String zkHost

#### collection

    protected String collection

#### params

    protected SolrParams params

#### cloudSolrClient

    protected transient CloudSolrClient cloudSolrClient

#### tupleStream

    protected transient TupleStream tupleStream

#### streamContext

    protected transient StreamContext streamContext

### Constructor Detail

#### SqlStream

    public SqlStream(String zkHost,
                     String collectionName,
                     SolrParams params)
              throws IOException

Parameters:
  `zkHost` - Zookeeper ensemble connection string
  `collectionName` - Name of the collection to operate on
  `params` - Map<String, String> of parameter/value pairs
Throws:
  `IOException` - Something went wrong

  This form does not allow specifying multiple clauses, say "fq" clauses, use the form that takes a SolrParams. Transition code can call the preferred method that takes SolrParams by calling CloudSolrStream(zkHost, collectionName, new ModifiableSolrParams(SolrParams.toMultiMap(new NamedList(Map<String, String>)));

#### SqlStream

    public SqlStream(StreamExpression expression,
                     StreamFactory factory)
              throws IOException

Throws:
  `IOException`

### Method Detail

#### toExpression

    public StreamExpression toExpression(StreamFactory factory)
                                  throws IOException

Specified by:
  `toExpression` in interface `Expressible`
Throws:
  `IOException`

#### toExplanation

    public Explanation toExplanation(StreamFactory factory)
                              throws IOException

Description copied from interface: `Expressible`
Returns an explanation about the stream object

Specified by:
  `toExplanation` in interface `Expressible`
Specified by:
  `toExplanation` in class `TupleStream`
Parameters:
  `factory` - Stream factory for this, contains information about the function name
Returns:
  Explanation about this stream object containing explanations of any child stream objects
Throws:
  `IOException` - throw on any error

#### init

    protected void init(String collectionName,
                        String zkHost,
                        SolrParams params)
                 throws IOException

Throws:
  `IOException`

#### setStreamContext

    public void setStreamContext(StreamContext context)

Specified by:
  `setStreamContext` in class `TupleStream`

#### open

    public void open()
              throws IOException

Specified by:
  `open` in class `TupleStream`
Throws:
  `IOException`

#### children

    public List<TupleStream> children()

Specified by:
  `children` in class `TupleStream`

#### constructStream

    protected void constructStream()
                            throws IOException

Throws:
  `IOException`

#### close

    public void close()
               throws IOException

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in class `TupleStream`
Throws:
  `IOException`

#### getStreamSort

    public StreamComparator getStreamSort()

Return the stream sort - ie, the order in which records are returned

Specified by:
  `getStreamSort` in class `TupleStream`

#### read

    public Tuple read()
               throws IOException

Specified by:
  `read` in class `TupleStream`
Throws:
  `IOException`